"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Contains definitions specific to sensors.

Copyright:
Copyright 2022 Frequenz Energy-as-a-Service GmbH

License:
MIT
"""
import builtins
import collections.abc
import frequenz.api.common.components_pb2
import frequenz.api.microgrid.common_pb2
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _ComponentState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ComponentStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ComponentState.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    COMPONENT_STATE_UNSPECIFIED: _ComponentState.ValueType  # 0
    """Unspecified state."""
    COMPONENT_STATE_OK: _ComponentState.ValueType  # 1
    """The sensor is behaving as expected."""
    COMPONENT_STATE_ERROR: _ComponentState.ValueType  # 2
    """The sensor is in an error state."""

class ComponentState(_ComponentState, metaclass=_ComponentStateEnumTypeWrapper):
    """Enumerated sensor states."""

COMPONENT_STATE_UNSPECIFIED: ComponentState.ValueType  # 0
"""Unspecified state."""
COMPONENT_STATE_OK: ComponentState.ValueType  # 1
"""The sensor is behaving as expected."""
COMPONENT_STATE_ERROR: ComponentState.ValueType  # 2
"""The sensor is in an error state."""
global___ComponentState = ComponentState

class _ErrorCode:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _ErrorCodeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_ErrorCode.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ERROR_CODE_UNSPECIFIED: _ErrorCode.ValueType  # 0
    """Unspecified."""

class ErrorCode(_ErrorCode, metaclass=_ErrorCodeEnumTypeWrapper):
    """Enumerated sensor error codes."""

ERROR_CODE_UNSPECIFIED: ErrorCode.ValueType  # 0
"""Unspecified."""
global___ErrorCode = ErrorCode

class _SensorMetric:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _SensorMetricEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_SensorMetric.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    SENSOR_METRIC_UNSPECIFIED: _SensorMetric.ValueType  # 0
    """Unspecified."""
    SENSOR_METRIC_TEMPERATURE: _SensorMetric.ValueType  # 1
    """Temperature.
    In Celsius (°C).
    """
    SENSOR_METRIC_HUMIDITY: _SensorMetric.ValueType  # 2
    """Humidity
    In percentage (%).
    """
    SENSOR_METRIC_PRESSURE: _SensorMetric.ValueType  # 3
    """Pressure
    In Pascal (Pa).
    """
    SENSOR_METRIC_IRRADIANCE: _SensorMetric.ValueType  # 4
    """Irradiance / Radiation flux
    In watts per square meter (W / m^2).
    """
    SENSOR_METRIC_VELOCITY: _SensorMetric.ValueType  # 5
    """Velocity
    In meters per second (m / s).
    """
    SENSOR_METRIC_ACCELERATION: _SensorMetric.ValueType  # 6
    """Acceleration.
    In meters per second per second (m / s^2)
    """
    SENSOR_METRIC_ANGLE: _SensorMetric.ValueType  # 7
    """Metric to represent angles, for metrics like direction.
    In angles with respect to the (magnetic) North (°).
    """
    SENSOR_METRIC_DEW_POINT: _SensorMetric.ValueType  # 8
    """Dew point.
    The temperature at which the air becomes saturated with water vapor.

    In Celsius (°C).
    """

class SensorMetric(_SensorMetric, metaclass=_SensorMetricEnumTypeWrapper):
    """The type of the metric reported in a sensor data sample."""

SENSOR_METRIC_UNSPECIFIED: SensorMetric.ValueType  # 0
"""Unspecified."""
SENSOR_METRIC_TEMPERATURE: SensorMetric.ValueType  # 1
"""Temperature.
In Celsius (°C).
"""
SENSOR_METRIC_HUMIDITY: SensorMetric.ValueType  # 2
"""Humidity
In percentage (%).
"""
SENSOR_METRIC_PRESSURE: SensorMetric.ValueType  # 3
"""Pressure
In Pascal (Pa).
"""
SENSOR_METRIC_IRRADIANCE: SensorMetric.ValueType  # 4
"""Irradiance / Radiation flux
In watts per square meter (W / m^2).
"""
SENSOR_METRIC_VELOCITY: SensorMetric.ValueType  # 5
"""Velocity
In meters per second (m / s).
"""
SENSOR_METRIC_ACCELERATION: SensorMetric.ValueType  # 6
"""Acceleration.
In meters per second per second (m / s^2)
"""
SENSOR_METRIC_ANGLE: SensorMetric.ValueType  # 7
"""Metric to represent angles, for metrics like direction.
In angles with respect to the (magnetic) North (°).
"""
SENSOR_METRIC_DEW_POINT: SensorMetric.ValueType  # 8
"""Dew point.
The temperature at which the air becomes saturated with water vapor.

In Celsius (°C).
"""
global___SensorMetric = SensorMetric

@typing_extensions.final
class Metadata(google.protobuf.message.Message):
    """The sensor metadata."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TYPE_FIELD_NUMBER: builtins.int
    type: frequenz.api.common.components_pb2.SensorType.ValueType
    """The sensor type."""
    def __init__(
        self,
        *,
        type: frequenz.api.common.components_pb2.SensorType.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["type", b"type"]) -> None: ...

global___Metadata = Metadata

@typing_extensions.final
class State(google.protobuf.message.Message):
    """State message."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    COMPONENT_STATE_FIELD_NUMBER: builtins.int
    component_state: global___ComponentState.ValueType
    """The state of the overall component."""
    def __init__(
        self,
        *,
        component_state: global___ComponentState.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["component_state", b"component_state"]) -> None: ...

global___State = State

@typing_extensions.final
class Error(google.protobuf.message.Message):
    """Error message."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    CODE_FIELD_NUMBER: builtins.int
    LEVEL_FIELD_NUMBER: builtins.int
    MSG_FIELD_NUMBER: builtins.int
    code: global___ErrorCode.ValueType
    """The error code."""
    level: frequenz.api.microgrid.common_pb2.ErrorLevel.ValueType
    """The error severity level."""
    msg: builtins.str
    """The error message."""
    def __init__(
        self,
        *,
        code: global___ErrorCode.ValueType = ...,
        level: frequenz.api.microgrid.common_pb2.ErrorLevel.ValueType = ...,
        msg: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["code", b"code", "level", b"level", "msg", b"msg"]) -> None: ...

global___Error = Error

@typing_extensions.final
class SensorData(google.protobuf.message.Message):
    """A value of a single metric."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VALUE_FIELD_NUMBER: builtins.int
    SENSOR_METRIC_FIELD_NUMBER: builtins.int
    value: builtins.float
    """The metric value."""
    sensor_metric: global___SensorMetric.ValueType
    """The metric name."""
    def __init__(
        self,
        *,
        value: builtins.float = ...,
        sensor_metric: global___SensorMetric.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["sensor_metric", b"sensor_metric", "value", b"value"]) -> None: ...

global___SensorData = SensorData

@typing_extensions.final
class Data(google.protobuf.message.Message):
    """Sensor data."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SENSOR_DATA_FIELD_NUMBER: builtins.int
    @property
    def sensor_data(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___SensorData]:
        """AC metrics of the inverter."""
    def __init__(
        self,
        *,
        sensor_data: collections.abc.Iterable[global___SensorData] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["sensor_data", b"sensor_data"]) -> None: ...

global___Data = Data

@typing_extensions.final
class Properties(google.protobuf.message.Message):
    """Sensor properties."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FIRMWARE_VER_FIELD_NUMBER: builtins.int
    firmware_ver: builtins.str
    """The firmware version of the component."""
    def __init__(
        self,
        *,
        firmware_ver: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["firmware_ver", b"firmware_ver"]) -> None: ...

global___Properties = Properties

@typing_extensions.final
class Sensor(google.protobuf.message.Message):
    """Sensor details"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PROPERTIES_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    ERRORS_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    @property
    def properties(self) -> global___Properties:
        """The component properties"""
    @property
    def state(self) -> global___State:
        """The sensor's state."""
    @property
    def errors(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Error]:
        """A list of errors encountered the component. An empty list implies no error."""
    @property
    def data(self) -> global___Data:
        """Sensor data object."""
    def __init__(
        self,
        *,
        properties: global___Properties | None = ...,
        state: global___State | None = ...,
        errors: collections.abc.Iterable[global___Error] | None = ...,
        data: global___Data | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["data", b"data", "properties", b"properties", "state", b"state"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["data", b"data", "errors", b"errors", "properties", b"properties", "state", b"state"]) -> None: ...

global___Sensor = Sensor
